library dipnav;

import 'package:flutter/widgets.dart';
import 'package:flutter_dipnav/src/dip_nav_router.dart';

export 'src/dip_nav_router.dart';

/// Extension to get [DipNavRouter] from the [BuildContext].
extension DipNavExtension on BuildContext {
  DipNavRouter get dipNav {
    return DipNav.of(this).router;
  }
}

/// The widget that propagate [DipNavRouter] down the tree.
class DipNav extends InheritedWidget {
  /// {@macro flutter_dipnav.DipNavRouter}
  final DipNavRouter router;

  DipNav({Key? key, required this.router, required Widget child})
      : super(key: key, child: child);

  static DipNav of(BuildContext context) {
    final DipNav? result = context.dependOnInheritedWidgetOfExactType<DipNav>();
    assert(result != null, 'No DipNav found in context');
    return result!;
  }

  @override
  bool updateShouldNotify(covariant DipNav oldWidget) {
    return router != oldWidget.router;
  }
}
